/*
** RTCC Alarm demo
**
** 8/09/06 LDJ v.1.0
*/

#include <p24fxxxx.h>

_CONFIG2( IESO_OFF & FNOSC_PRIPLL & FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_XT)
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & ICS_PGx2 & FWDTEN_OFF & WINDIS_OFF);

 
void initRTCC( void)
{   
    // Enables the OSCON write and set 
    //_SOSCEN =1;
 	asm volatile ("mov #OSCCON,W1");
	asm volatile ("mov.b	#0x46, W2");    // unlock sequence
	asm volatile ("mov.b	#0x57, W3");
	asm volatile ("mov.b	#0x02, W0");    // SOSCEN =1
	asm volatile ("mov.b	W2, [W1]");
	asm volatile ("mov.b	W3, [W1]");
	asm volatile ("mov.b	W0, [W1]");		
 

    //_RTCWREN = 1;       // unlock setting
	asm volatile("disi	#5");
	asm volatile("mov	#0x55, w7");
	asm volatile("mov	w7, _NVMKEY");
	asm volatile("mov	#0xAA, w8");
	asm volatile("mov	w8, _NVMKEY");
    asm volatile("bset	_RCFGCAL, #13");    // RTCWREN =1;
	asm volatile("nop");
	asm volatile("nop");

    _RTCEN = 0;         // disable the clock

    // set 12/01/2006 WED 12:01:30
    _RTCPTR = 3;        // start the sequence
    RTCVAL = 0x2006;    // YEAR
    RTCVAL = 0x1100;    // MONTH-1/DAY-1
    RTCVAL = 0x0312;    // WEEKDAY/HOURS
    RTCVAL = 0x0130;    // MINUTES/SECONDS

    // optional calibration
    //_CAL = 0x00;      

    // lock and enable 
    _RTCEN = 1;         // start the clock
    _RTCWREN = 0;       // lock settings
} // initRTCC


void setALARM( void)
{
    // disable alarm
    _ALRMEN = 0;

    // set the ALARM for a specific day of the year (my birthday)
    _ALRMPTR = 2;       // start the sequence
    ALRMVAL = 0x1124;   // MONTH-1/DAY-1
    ALRMVAL = 0x0006;   // WEEKDAY/HOUR
    ALRMVAL = 0x0000;   // MINUTES/SECONDS

    // set the repeat counter
    _ARPT = 0;          // once
    _CHIME = 1;         // indefinitely

    // set the alarm mask 
//    _AMASK = 0b1001;    // once a year
    _AMASK = 0b0010;    // every 10 seconds
//    _AMASK = 0b0001;    // every second

    _ALRMEN = 1;        // enable alarm
    _RTCIF = 0;         // clear flag
    _RTCIE = 1;         // enable interrupt

} // set ALARM


void _ISR _RTCCInterrupt( void)
{
    // will call this routine once every four years on Feb29th!
    // your code here
    // ...
    _RA0 = 1- _RA0; // toggle LED0

    _RTCIF = 0;     // clear flag, see ya in four...

} // RTCC interrupt service routine


main()
{
    // initialization
    TRISA = 0xff80;
    initRTCC();
    setALARM();

    while( 1)   // main loop 
    {
        // wait here
    } // main loop

} // main
